diff --git a/src/preprocessors/Stream5/snort_stream5_sctp.h b/src/preprocessors/Stream5/snort_stream5_sctp.h
new file mode 100644
index 0000000..e955195
--- /dev/null
+++ b/src/preprocessors/Stream5/snort_stream5_sctp.h
@@ -0,0 +1,264 @@
+/****************************************************************************
+ *
+ * Copyright (C) 2005-2013 Sourcefire, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2 as
+ * published by the Free Software Foundation.  You may not use, modify or
+ * distribute this program under any other version of the GNU General
+ * Public License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ ****************************************************************************/
+
+#ifndef SNORT_STREAM5_SCTP_H_
+#define SNORT_STREAM5_SCTP_H_
+
+#include "ipv6_port.h"
+#include "stream5_common.h"
+#include "stream5_paf.h"
+#include "sfPolicy.h"
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpDataBlock
+ * @sip: Snort IP structure for source.
+ * @dip: Snort IP structure for destination.
+ * @vtag: Verification tag from the SCTP common header.
+ * @tsn: Transmission Sequence Number from the DATA chunk.
+ * @length: Chunk length.
+ * @sid: Stream ID.
+ * @ssn: Stream Sequence Number.
+ * @flags: DATA chunk flags field (IUBE).
+ * @pad: Padding to align on a 32-bit boundary.
+ */
+/*
+typedef struct _SctpDataBlock
+{
+    snort_ip     sip;
+    snort_ip     dip;
+    uint32_t     vtag;
+    uint32_t     tsn;
+    uint16_t     length;
+    uint16_t     sid;
+    uint16_t     ssn;
+    uint8_t      flags;
+    uint8_t      pad;
+} SctpDataBlock;
+*/
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpStreamSegment
+ * @pkth: Pointer to packet header from DAQ.
+ * @pktOrig: Pointer to original Packet structure.
+ * @pkt: Pointer to Packet structure (modified?).
+ * @data: Pointer to data (?).
+ * @payload: Pointer to packet payload.
+ * @prev: Pointer to previous SctpStreamMessage.
+ * @next: Pointer to next SctpStreamMessage.
+ * @vtag: Verification tag.
+ * @tsn: Transmission Sequence Number.
+ * @length: Chunk length.
+ * @sid: Stream ID.
+ * @ssn: Stream Sequence Number.
+ * @cflags: Chunk flags.
+ * @msgflags: SctpStreamMessage flags.
+ */
+/*
+typedef struct _SctpStreamMessage
+{
+    DAQ_PktHdr_t pkth;
+    uint8_t      *pktOrig;
+    uint8_t      *pkt;
+    uint8_t      *data;
+    uint8_t      *payload;
+    struct       _SctpStreamMessage *prev;
+    struct       _SctpStreamMessage *next;
+    uint32_t     vtag;
+    uint32_t     tsn;
+    uint32_t     caplen;
+    uint16_t     length;
+    uint16_t     sid;
+    uint16_t     ssn;
+    uint8_t      cflags;
+    uint8_t      msgflags;
+} SctpStreamMessage;
+*/
+
+
+#define SCTP_S5_HMAC_SHA1           0x0001        /* HMAC SHA-1 */
+#define SCTP_S5_HMAC_SHA256         0x0002        /* HMAC SHA-256 */
+
+#define SCTP_S5_EXT_ASCONF          0x0001        /* ASCONF chunk supported. */
+#define SCTP_S5_EXT_ASCONF_ACK      0x0002        /* ASCONF-ACK chunk supported. */
+#define SCTP_S5_EXT_AUTH            0x0004        /* AUTH chunk supported. */
+#define SCTP_S5_EXT_FWD_TSN         0x0008        /* FORWARD-TSN chunk supported. */
+#define SCTP_S5_EXT_PKTDROP         0x0010        /* PKTDROP chunk supported. */
+#define SCTP_S5_EXT_RECONFIG        0x0020        /* RE-CONFIG chunk supported. */
+
+#define SCTP_S5_FLAG_ECN            0x0001        /* ECN parameter (0x8000). */
+#define SCTP_S5_FLAG_NONCE          0x0002        /* Nonce-Supported parameter (0x8001). */
+#define SCTP_S5_FLAG_FWD_TSN        0x0004        /* FORWARD-TSN parameter (0xc000). */
+
+#define SCTP_S5_ADDR_IPV4           0x0001        /* IPv4 addresses supported. */
+#define SCTP_S5_ADDR_IPV6           0x0002        /* IPv6 addresses supported. */
+#define SCTP_S5_ADDR_DNS            0x0004        /* Hostnames supported. */
+
+#define SCTP_S5_AUTH_DATA           0x00000001    /* Authenticated DATA chunk */
+#define SCTP_S5_AUTH_SACK           0x00000002    /* Authenticated SACK chunk */
+#define SCTP_S5_AUTH_HEARTBEAT      0x00000004    /* Authenticated HEARTBEAT chunk */
+#define SCTP_S5_AUTH_HEARTBEAT_ACK  0x00000008    /* Authenticated HEARTBEAT-ACK chunk */
+#define SCTP_S5_AUTH_ABORT          0x00000010    /* Authenticated ABORT chunk */
+#define SCTP_S5_AUTH_SHUTDOWN       0x00000020    /* Authenticated SHUTDOWN chunk */
+#define SCTP_S5_AUTH_SHUTDOWN_ACK   0x00000040    /* Authenticated SHUTDOWN-ACK chunk */
+#define SCTP_S5_AUTH_ERROR          0x00000080    /* Authenticated ERROR chunk */
+#define SCTP_S5_AUTH_ECNE           0x00000100    /* Authenticated ECNE chunk */
+#define SCTP_S5_AUTH_CWR            0x00000200    /* Authenticated CWR chunk */
+#define SCTP_S5_AUTH_ASCONF_ACK     0x00000400    /* Authenticated ASCONF-ACK chunk */
+#define SCTP_S5_AUTH_PKTDROP        0x00000800    /* Authenticated PKTDROP chunk */
+#define SCTP_S5_AUTH_RECONFIG       0x00001000    /* Authenticated RE-CONFIG chunk */
+#define SCTP_S5_AUTH_PAD            0x00002000    /* Authenticated PAD chunk */
+#define SCTP_S5_AUTH_FORWARD_TSN    0x00004000    /* Authenticated FORWARD-TSN chunk */
+#define SCTP_S5_AUTH_ASCONF         0x00008000    /* Authenticated ASCONF chunk */
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpPeerProperties
+ * @extensions: uint16_t flag variable of supported SCTP extensions.
+ * @flags: uint16_t flag variable of miscellaneous SCTP bits (not extensions).
+ * @addrtypes: uint16_t flag variable of the supported address types.
+ * @cookie_len: uint16_t value to hold the size of the state cookie.
+ * @cookie: pointer to a MemBucket to hold the state cookie.
+ */
+/*
+typedef struct _SctpPeerBits
+{
+    uint32_t auth_chunks;
+    uint16_t extensions;
+    uint16_t flags;
+    uint16_t addr_types;
+    uint16_t hmac_types;
+    uint16_t cookie_len;
+    uint8_t pad;
+    uint8_t *cookie;
+} SctpPeerBits;
+*/
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpPeers
+ * @client_bits: pointer to client-specific SctpPeerBits structure.
+ * @server_bits: pointer to server-specific SctpPeerBits structure.
+ */
+/*
+typedef struct _SctpPeers
+{
+    SctpPeerBits *client_bits;
+    SctpPeerBits *server_bits;
+} SctpPeers;
+*/
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpStreamTracker
+ * @flush_mgr: Pointer to FlushMgr structure.
+ * @paf_state: Pointer to PAF_State structure (DO NOT MODIFY!)
+ * @alerts[]: Array of Stream5AlertInfo structures.
+ * @sctp_policy: Pointer to Stream5SctpPolicy structure.
+ * @msghead: Pointer to first queued message.
+ * @msgtail: Pointer to last queued message.
+ * @msgnext: Pointer to next queued message (to flush?).
+ * @vtag: Verification tag.
+ * @itag: Initiate tag from the INIT or INIT-ACK.
+ * @init_tsn: Initial TSN for this side of the conversation.
+ * @l_unsack_tsn: [Local]: UnSACK'ed TSN.
+ * @l_next_tsn: [Local]: Next expected TSN.
+ * @r_next_tsn: [Remote]: Next expected TSN.
+ * @msghead_tsn: TSN of first queued message.
+ * @msg_count: Number of currently queued messages.
+ * @msg_bytes_total: Total amount of message bytes queued.
+ * @msg_flush_count: Number of flushed queued messages.
+ * @macaddr: MAC Address.
+ * @flags: Bitmap flags (TF_*).
+ * @state: SCTP Stream State.
+ * @alert_count: Number of alerts stored (up to MAX_SESSION_ALERTS). 
+ * @pad: Padding to align on a 32-bit boundary.
+ */
+/*
+typedef struct _SctpStreamTracker
+{
+    FlushMgr  flush_mgr;
+    PAF_State paf_state;
+    Stream5AlertInfo alerts[MAX_SESSION_ALERTS];
+    Stream5SctpPolicy *sctp_policy;
+    SctpStreamMessage *msghead;
+    SctpStreamMessage *msgtail;
+    SctpStreamMessage *msgnext;
+    SctpPeerBits *peerbits;
+    uint64_t macaddr;
+    uint32_t vtag;
+    uint32_t itag;
+    uint32_t a_rwnd;
+    uint32_t init_tsn;
+    uint32_t l_unsack_tsn;
+    uint32_t l_next_tsn;
+    uint32_t r_next_tsn;
+    uint32_t msghead_tsn;
+    uint32_t msg_count;
+    uint32_t msg_bytes_total;
+    uint32_t msg_flush_count;
+    uint16_t nr_out_streams;
+    uint16_t nr_in_streams;
+    uint8_t  flags;
+    uint8_t  state;
+    uint8_t  alert_count;
+    uint8_t  pad;
+} SctpStreamTracker;
+*/
+
+/* XXX: Not implemented yet! */
+/**
+ * struct SctpAssociation
+ * @client: Pointer to SctpStreamTracker structure for the client.
+ * @server: Pointer to SctpStreamTracker structure for the server.
+ * @lwssn: Lightweight session data.
+ * @ssn_time: [DEBUG]: Session time.
+ */
+/*
+typedef struct _SctpAssociation
+{
+    SctpStreamTracker *client;
+    SctpStreamTracker *server;
+    Stream5LWSession *lwssn;
+#ifdef DEBUG
+    struct timeval ssn_time;
+#endif
+} SctpAssociation;
+*/
+
+
+/* Prototypes. */
+void Stream5CleanSctp(void);
+void Stream5ResetSctp(void);
+void Stream5InitSctp(Stream5GlobalConfig *);
+void Stream5SctpPolicyInit(Stream5SctpConfig *, char *);
+int Stream5VerifySctpConfig(Stream5SctpConfig *, tSfPolicyId);
+int Stream5ProcessSctp(Packet *, Stream5LWSession *, Stream5SctpPolicy *, SessionKey *);
+void SctpUpdateDirection(Stream5LWSession *ssn, char dir, snort_ip_p ip, uint16_t port);
+Stream5LWSession *GetLWSctpSession(SessionKey *key);
+void s5SctpSetPortFilterStatus(unsigned short port, uint16_t status, tSfPolicyId policyId, int parsing);
+int s5SctpGetPortFilterStatus(unsigned short port, tSfPolicyId policyId, int parsing);
+void Stream5SctpConfigFree(Stream5SctpConfig *);
+uint32_t Stream5GetSctpPrunes(void);
+void Stream5ResetSctpPrunes(void);
+
+#endif /* SNORT_STREAM5_SCTP_H_ */
diff --git a/src/preprocessors/Stream5/snort_stream5_session.c b/src/preprocessors/Stream5/snort_stream5_session.c
index 3cdb971..5c5da29 100644
--- a/src/preprocessors/Stream5/snort_stream5_session.c
+++ b/src/preprocessors/Stream5/snort_stream5_session.c
@@ -4,6 +4,9 @@
 ** Copyright (C) 2005-2013 Sourcefire, Inc.
 ** AUTHOR: Steven Sturges <ssturges () sourcefire com>
 **
+** SCTP bits Copyright (C) 2013
+** Joshua Kinard <kumba12345 () gmail com>
+**
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License Version 2 as
 ** published by the Free Software Foundation.  You may not use, modify or
@@ -116,6 +119,7 @@ int GetLWSessionKeyFromIpPort(
         {
             case IPPROTO_TCP:
             case IPPROTO_UDP:
+            case IPPROTO_SCTP:
                 sport = srcPort;
                 dport = dstPort;
                 break;
@@ -182,6 +186,7 @@ int GetLWSessionKeyFromIpPort(
         {
             case IPPROTO_TCP:
             case IPPROTO_UDP:
+            case IPPROTO_SCTP:
                 sport = srcPort;
                 dport = dstPort;
                 break;
@@ -308,6 +313,17 @@ void GetLWPacketDirection(Packet *p, Stream5LWSession *ssn)
                     p->packet_flags |= PKT_FROM_SERVER;
                 }
             }
+            else if (GET_IPH_PROTO(p) == IPPROTO_SCTP)
+            {
+                if (p->sctph->sh_sport == ssn->client_port)
+                {
+                    p->packet_flags |= PKT_FROM_CLIENT;
+                }
+                else
+                {
+                    p->packet_flags |= PKT_FROM_SERVER;
+                }
+            }
             else
             {
                 p->packet_flags |= PKT_FROM_CLIENT;
@@ -337,6 +353,17 @@ void GetLWPacketDirection(Packet *p, Stream5LWSession *ssn)
                     p->packet_flags |= PKT_FROM_CLIENT;
                 }
             }
+            else if (GET_IPH_PROTO(p) == IPPROTO_SCTP)
+            {
+                if (p->sctph->sh_dport == ssn->client_port)
+                {
+                    p->packet_flags |= PKT_FROM_SERVER;
+                }
+                else
+                {
+                    p->packet_flags |= PKT_FROM_CLIENT;
+                }
+            }
             else
             {
                 p->packet_flags |= PKT_FROM_SERVER;
@@ -369,6 +396,17 @@ void GetLWPacketDirection(Packet *p, Stream5LWSession *ssn)
                     p->packet_flags |= PKT_FROM_SERVER;
                 }
             }
+            else if (GET_IPH_PROTO(p) == IPPROTO_SCTP)
+            {
+                if (p->sctph->sh_sport == ssn->client_port)
+                {
+                    p->packet_flags |= PKT_FROM_CLIENT;
+                }
+                else
+                {
+                    p->packet_flags |= PKT_FROM_SERVER;
+                }
+            }
             else
             {
                 p->packet_flags |= PKT_FROM_CLIENT;
@@ -398,6 +436,17 @@ void GetLWPacketDirection(Packet *p, Stream5LWSession *ssn)
                     p->packet_flags |= PKT_FROM_CLIENT;
                 }
             }
+            else if (GET_IPH_PROTO(p) == IPPROTO_SCTP)
+            {
+                if (p->sctph->sh_dport == ssn->client_port)
+                {
+                    p->packet_flags |= PKT_FROM_SERVER;
+                }
+                else
+                {
+                    p->packet_flags |= PKT_FROM_CLIENT;
+                }
+            }
             else
             {
                 p->packet_flags |= PKT_FROM_SERVER;
@@ -508,6 +557,7 @@ int DeleteLWSession(Stream5SessionCache *sessionCache,
     Stream5GlobalConfig *save_global_eval_config = s5_global_eval_config;
     Stream5TcpConfig *save_tcp_eval_config = s5_tcp_eval_config;
     Stream5UdpConfig *save_udp_eval_config = s5_udp_eval_config;
+    Stream5SctpConfig *save_sctp_eval_config = s5_sctp_eval_config;
     Stream5IcmpConfig *save_icmp_eval_config = s5_icmp_eval_config;
 
     int ret;
@@ -531,7 +581,7 @@ int DeleteLWSession(Stream5SessionCache *sessionCache,
     sfip_set_ip(&server_ip, &ssn->server_ip);
 
     /*
-     * Call callback to cleanup the protocol (TCP/UDP/ICMP)
+     * Call callback to cleanup the protocol (TCP/UDP/SCTP/ICMP)
      * specific session details
      */
     if (sessionCache->cleanup_fcn)
@@ -575,6 +625,7 @@ int DeleteLWSession(Stream5SessionCache *sessionCache,
     s5_global_eval_config = save_global_eval_config;
     s5_tcp_eval_config = save_tcp_eval_config;
     s5_udp_eval_config = save_udp_eval_config;
+    s5_sctp_eval_config = save_sctp_eval_config;
     s5_icmp_eval_config = save_icmp_eval_config;
 
     return ret;
@@ -1113,6 +1164,11 @@ Stream5SetRuntimeConfiguration(
                 return -1;
             s5_udp_eval_config = pPolicyConfig->udp_config;
             break;
+        case IPPROTO_SCTP:
+            if (pPolicyConfig->sctp_config == NULL)
+                return -1;
+            s5_sctp_eval_config = pPolicyConfig->sctp_config;
+            break;
         case IPPROTO_ICMP:
             if (pPolicyConfig->icmp_config == NULL)
                 return -1;
diff --git a/src/preprocessors/Stream5/stream5_common.c b/src/preprocessors/Stream5/stream5_common.c
index 829aad9..fd8fda3 100644
--- a/src/preprocessors/Stream5/stream5_common.c
+++ b/src/preprocessors/Stream5/stream5_common.c
@@ -39,6 +39,7 @@
 #include "sp_dynamic.h"
 #include "snort_stream5_tcp.h"
 #include "snort_stream5_udp.h"
+#include "snort_stream5_sctp.h"
 #include "snort_stream5_icmp.h"
 #include "snort_stream5_ip.h"
 #include "parser.h"
@@ -92,6 +93,10 @@ int Stream5Expire(Packet *p, Stream5LWSession *lwssn)
                 s5stats.udp_timeouts++;
                 //DeleteLWSession(udp_lws_cache, lwssn);
                 break;
+            case IPPROTO_SCTP:
+                s5stats.sctp_timeouts++;
+                //DeleteLWSession(sctp_lws_cache, lwssn);
+                break;
             case IPPROTO_ICMP:
                 s5stats.icmp_timeouts++;
                 //DeleteLWSession(icmp_lws_cache, lwssn);
@@ -206,6 +211,8 @@ static inline RuleTreeNode * protocolRuleList(RuleListNode *rule, int protocol)
             return rule->RuleList->TcpList;
         case IPPROTO_UDP:
             return rule->RuleList->UdpList;
+        case IPPROTO_SCTP:
+            return rule->RuleList->SctpList;
         case IPPROTO_ICMP:
             break;
         default:
@@ -216,15 +223,17 @@ static inline RuleTreeNode * protocolRuleList(RuleListNode *rule, int protocol)
 #endif
 static inline char * getProtocolName (int protocol)
 {
-    static char *protocolName[] = {"TCP", "UDP", "ICMP"};
+    static char *protocolName[] = {"TCP", "UDP", "SCTP", "ICMP"};
     switch (protocol)
     {
         case IPPROTO_TCP:
             return protocolName[0];
         case IPPROTO_UDP:
             return protocolName[1];
-        case IPPROTO_ICMP:
+        case IPPROTO_SCTP:
             return protocolName[2];
+        case IPPROTO_ICMP:
+            return protocolName[3];
             break;
         default:
             break;
@@ -270,7 +279,7 @@ void setPortFilterList(
     OptTreeNode *otn;
     int inspectSrc, inspectDst;
     char any_any_flow = 0;
-    IgnoredRuleList *pIgnoredRuleList = NULL;     ///list of ignored rules
+    IgnoredRuleList *pIgnoredRuleList = NULL;     /* List of ignored rules */
     char *protocolName;
     SFGHASH_NODE *hashNode;
     int flowBitIsSet = 0;
@@ -282,7 +291,9 @@ void setPortFilterList(
                    __FILE__, __LINE__);
     }
 
-    if ((protocol == IPPROTO_TCP) && (ignoreAnyAnyRules == 0))
+    if (((protocol == IPPROTO_TCP) ||
+         (protocol == IPPROTO_SCTP)) &&
+        (ignoreAnyAnyRules == 0))
     {
         int j;
         for (j=0; j<MAX_PORTS; j++)
@@ -294,14 +305,13 @@ void setPortFilterList(
 
     protocolName = getProtocolName(protocol);
 
-    /* Post-process TCP rules to establish TCP ports to inspect. */
+    /* Post-process TCP/SCTP rules to establish TCP/SCTP ports to inspect. */
     for (hashNode = sfghash_findfirst(sc->otn_map);
          hashNode;
          hashNode = sfghash_findnext(sc->otn_map))
     {
         otn = (OptTreeNode *)hashNode->data;
         flowBitIsSet = Stream5OtnHasFlowOrFlowbit(otn);
-
         rtn = getRtnFromOtn(otn, policyId);
 
         if (!rtn)
@@ -311,29 +321,28 @@ void setPortFilterList(
 
         if (rtn->proto == protocol)
         {
-            //do operation
+            /* Do operation */
             inspectSrc = inspectDst = 0;
             if (PortObjectHasAny(rtn->src_portobject))
-            {
                 inspectSrc = -1;
-            }
             else
             {
                 port_array = PortObjectCharPortArray(port_array, rtn->src_portobject, &num_ports);
                 if (port_array && num_ports != 0)
                 {
                     inspectSrc = 1;
-                    for (i=0;i<SFPO_MAX_PORTS;i++)
+                    for (i = 0; i < SFPO_MAX_PORTS; i++)
                     {
                         if (port_array[i])
                         {
                             portList[i] |= PORT_MONITOR_INSPECT;
+
                             /* port specific rule */
-                                /* Look for an OTN with flow or flowbits keyword */
-                                if (flowBitIsSet)
-                                {
-                                    portList[i] |= PORT_MONITOR_SESSION;
-                                }
+                            /* Look for an OTN with flow or flowbits keyword */
+                            if (flowBitIsSet)
+                            {
+                                portList[i] |= PORT_MONITOR_SESSION;
+                            }
                         }
                     }
                 }
@@ -343,6 +352,7 @@ void setPortFilterList(
                     port_array = NULL;
                 }
             }
+
             if (PortObjectHasAny(rtn->dst_portobject))
             {
                 inspectDst = -1;
@@ -353,16 +363,17 @@ void setPortFilterList(
                 if (port_array && num_ports != 0)
                 {
                     inspectDst = 1;
-                    for (i=0;i<SFPO_MAX_PORTS;i++)
+                    for (i = 0; i < SFPO_MAX_PORTS; i++)
                     {
                         if (port_array[i])
                         {
                             portList[i] |= PORT_MONITOR_INSPECT;
+
                             /* port specific rule */
-                                if (flowBitIsSet)
-                                {
-                                    portList[i] |= PORT_MONITOR_SESSION;
-                                }
+                            if (flowBitIsSet)
+                            {
+                                portList[i] |= PORT_MONITOR_SESSION;
+                            }
                         }
                     }
                 }
@@ -384,13 +395,14 @@ void setPortFilterList(
         }
     }
 
-    /* If portscan is tracking TCP/UDP, need to create
+    /* If portscan is tracking TCP/UDP/SCTP, need to create
      * sessions for all ports */
     if (((protocol == IPPROTO_UDP) && (ps_get_protocols(policyId) & PS_PROTO_UDP))
-     || ((protocol == IPPROTO_TCP) && (ps_get_protocols(policyId) & PS_PROTO_TCP)))
+     || ((protocol == IPPROTO_TCP) && (ps_get_protocols(policyId) & PS_PROTO_TCP))
+     || ((protocol == IPPROTO_SCTP) && (ps_get_protocols(policyId) & PS_PROTO_SCTP)))
     {
         int j;
-        for (j=0; j<MAX_PORTS; j++)
+        for (j = 0; j < MAX_PORTS; j++)
         {
             portList[j] |= PORT_MONITOR_SESSION;
         }
@@ -595,6 +607,12 @@ void Stream5FreeConfig(Stream5Config *config)
         config->udp_config = NULL;
     }
 
+    if (config->sctp_config != NULL)
+    {
+        Stream5SctpConfigFree(config->sctp_config);
+        config->sctp_config = NULL;
+    }
+
     if (config->icmp_config != NULL)
     {
         Stream5IcmpConfigFree(config->icmp_config);
diff --git a/src/preprocessors/Stream5/stream5_common.h b/src/preprocessors/Stream5/stream5_common.h
index 9bd7e0d..6cd2ae6 100644
--- a/src/preprocessors/Stream5/stream5_common.h
+++ b/src/preprocessors/Stream5/stream5_common.h
@@ -130,6 +130,21 @@
 
 #define TCP_HZ          100
 
+
+/* SCTP States. */
+/* XXX: Not implemented yet */
+#define STREAM5_SCTP_STATE_NONE                 0x0000
+#define STREAM5_SCTP_STATE_COOKIE_WAIT          0x0001
+#define STREAM5_SCTP_STATE_COOKIE_SENT          0x0002   /* Not in RFC4690 */
+#define STREAM5_SCTP_STATE_COOKIE_ECHOED        0x0004
+#define STREAM5_SCTP_STATE_ESTABLISHED          0x0008
+#define STREAM5_SCTP_STATE_SHUTDOWN_PENDING     0x0010
+#define STREAM5_SCTP_STATE_SHUTDOWN_SENT        0x0020
+#define STREAM5_SCTP_STATE_SHUTDOWN_RECEIVED    0x0040
+#define STREAM5_SCTP_STATE_SHUTDOWN_ACK_SENT    0x0080
+#define STREAM5_SCTP_STATE_CLOSED               0x0100
+
+
 /*  D A T A   S T R U C T U R E S  **********************************/
 typedef StreamSessionKey SessionKey;
 
@@ -194,10 +209,12 @@ typedef struct _Stream5GlobalConfig
     char       disabled;
     char       track_tcp_sessions;
     char       track_udp_sessions;
+    char       track_sctp_sessions;
     char       track_icmp_sessions;
     char       track_ip_sessions;
     uint32_t   max_tcp_sessions;
     uint32_t   max_udp_sessions;
+    uint32_t   max_sctp_sessions;
     uint32_t   max_icmp_sessions;
     uint32_t   max_ip_sessions;
     uint32_t   memcap;
@@ -313,6 +330,30 @@ typedef struct _Stream5UdpConfig
 
 } Stream5UdpConfig;
 
+typedef struct _Stream5SctpPolicy
+{
+    uint32_t   session_timeout;
+    uint32_t   max_queued_bytes;
+    uint32_t   max_queued_chunks;
+    uint32_t   hs_timeout;
+    uint16_t   flags;
+    IpAddrSet   *bound_addrs;
+    FlushConfig flush_config[MAX_PORTS];
+#ifdef TARGET_BASED
+    FlushConfig flush_config_protocol[MAX_PROTOCOL_ORDINAL];
+#endif
+} Stream5SctpPolicy;
+
+typedef struct _Stream5SctpConfig
+{
+    Stream5SctpPolicy *default_policy;
+    Stream5SctpPolicy **policy_list;
+    uint8_t num_policies;
+    uint8_t dummy;  /* For alignment */
+    uint16_t port_filter[MAX_PORTS + 1];
+
+} Stream5SctpConfig;
+
 typedef struct _Stream5IcmpPolicy
 {
     uint32_t   session_timeout;
@@ -344,6 +385,7 @@ typedef struct _Stream5Config
     Stream5GlobalConfig *global_config;
     Stream5TcpConfig *tcp_config;
     Stream5UdpConfig *udp_config;
+    Stream5SctpConfig *sctp_config;
     Stream5IcmpConfig *icmp_config;
     Stream5IpConfig *ip_config;
 
@@ -355,7 +397,7 @@ typedef struct _Stream5Config
 
 } Stream5Config;
 
-/**Common statistics for tcp and udp packets, maintained by port filtering.
+/* Common statistics for tcp, udp, and sctp packets, maintained by port filtering.
  */
 typedef struct {
     /**packets dropped without further processing by any preprocessor or
@@ -376,10 +418,12 @@ typedef struct _Stream5Stats
 {
     uint32_t   total_tcp_sessions;
     uint32_t   total_udp_sessions;
+    uint32_t   total_sctp_sessions;
     uint32_t   total_icmp_sessions;
     uint32_t   total_ip_sessions;
     uint32_t   tcp_prunes;
     uint32_t   udp_prunes;
+    uint32_t   sctp_prunes;
     uint32_t   icmp_prunes;
     uint32_t   ip_prunes;
     uint32_t   tcp_timeouts;
@@ -396,6 +440,12 @@ typedef struct _Stream5Stats
     uint32_t   udp_sessions_created;
     uint32_t   udp_sessions_released;
     uint32_t   udp_discards;
+    uint32_t   sctp_timeouts;
+    uint32_t   sctp_sessions_created;
+    uint32_t   sctp_sessions_released;
+    uint32_t   sctp_streammsgs_created;
+    uint32_t   sctp_streammsgs_released;
+    uint32_t   sctp_discards;
     uint32_t   icmp_timeouts;
     uint32_t   icmp_sessions_created;
     uint32_t   icmp_sessions_released;
@@ -404,6 +454,7 @@ typedef struct _Stream5Stats
     uint32_t   internalEvents;
     tPortFilterStats  tcp_port_filter;
     tPortFilterStats  udp_port_filter;
+    tPortFilterStats  sctp_port_filter;
 } Stream5Stats;
 
 /**Whether incoming packets should be ignored or processed.
@@ -468,6 +519,7 @@ extern uint32_t mem_in_use;
 extern Stream5GlobalConfig *s5_global_eval_config;
 extern Stream5TcpConfig *s5_tcp_eval_config;
 extern Stream5UdpConfig *s5_udp_eval_config;
+extern Stream5SctpConfig *s5_sctp_eval_config;
 extern Stream5IcmpConfig *s5_icmp_eval_config;
 extern Stream5IpConfig *s5_ip_eval_config;
 extern tSfPolicyUserContextId s5_config;
